
      PROGRAM PREP

      INTEGER*4 lll;
      INTEGER*4 n0f, n0b, J_multipol, K_multipol, NGH, NGL, broyd_nn;
      INTEGER*4 NBSX, nz, nr;

      parameter( NSIZE = 100000 );
      INTEGER*4 nz_spx(NSIZE),nr_spx(NSIZE),ml_spx(NSIZE);
      CHARACTER fg_spx(NSIZE);
      INTEGER*4 nf,ng;
      INTEGER*4 i,j;
      INTEGER*4 ml;
      CHARACTER fg1,fg2;
      INTEGER*4 ml1,ml2;

      INTEGER*4 WSIZE;
      INTEGER*4 nz1,nz2,nr1,nr2,NZZ,NRR,K;



      lll = 972;
      open( lll , file = 'dirhb.dat' , status = 'old' );
      read( lll , '(10x,2i5)') n0f , n0b
      read( lll , * );read( lll , * );read( lll , * );read( lll , * );
      read( lll , * );read( lll , * );read( lll , * );read( lll , * );
      read( lll , * );read( lll , * );read( lll , * );read( lll , * );
      read( lll , * );read( lll , * );read( lll , * );read( lll , * );
      read( lll , * );
      read( lll , * );

      read( lll , '(20x,i5)' ) NGH;
      read( lll , '(20x,i5)' ) NGL;

      read( lll , * );
      read( lll , '(20x,i5)' ) J_multipol;
      read( lll , '(20x,i5)' ) K_multipol;
      close( lll );


      if( MOD(n0f,2) .ne. 0 ) then
          stop 'n0f mora biti paran!';
      endif




c-----Racunam maksimalnu dimenziju bloka u U i V matricama (NBSX)
c-----(Zapravo izracunam broj stanja u omega^pi = 1/2^+ bloku jer je
c-----u njemu najvise stanja)
      NBSX = 0;
      do nz = 0 , n0f , 2
          nr = 0;
          do while( (2*nr+nz) .le. n0f )
              NBSX = NBSX + 1;
              nr = nr + 1;
          enddo
      enddo
      NBSX = NBSX * 2;

      do nz = 0 , n0f-1 , 2
          nr = 0;
          do while( (2*nr+nz) .le. n0f-1 )
              NBSX = NBSX + 1;
              nr = nr + 1;
          enddo
      enddo

      do nz = 1 , n0f+1 , 2
          nr = 0;
          do while( (2*nr+nz) .le. n0f+1 )
              NBSX = NBSX + 1;
              nr = nr + 1;
          enddo
      enddo
c---------------------------------------------------------





c-----Nastimavam najmanji potreban Broydenov nn da se ubrza broyden()
      nf = ((n0f+1)*(n0f+2)*(n0f+3))/6;
      ng = ((n0f+2)*(n0f+3)*(n0f+4))/6;
      if( nf+ng .gt. NSIZE ) then
          stop 'Error: nf+ng>NSIZE!';
      endif
      i = 0;
      do nz = 0 , n0f
          do nr = 0 , n0f
              do ml = -n0f , n0f
                  if( nz+2*nr+abs(ml) .le. n0f ) then
                      i = i + 1;
                      fg_spx(i) = 'f';
                      nz_spx(i) = nz;
                      nr_spx(i) = nr;
                      ml_spx(i) = ml;
                  endif
              enddo
          enddo
      enddo
      do nz = 0 , n0f+1
          do nr = 0 , n0f+1
              do ml = -(n0f+1) , n0f+1
                  if( nz+2*nr+abs(ml) .le. n0f+1 ) then
                      i = i + 1;
                      fg_spx(i) = 'g';
                      nz_spx(i) = nz;
                      nr_spx(i) = nr;
                      ml_spx(i) = ml;
                  endif
              enddo
          enddo
      enddo
      if( nf+ng .ne. i ) then
          stop 'Error: nf+ng!';
      endif




      broyd_nn = 0;
      do i = 1 , nf+ng
          fg1 = fg_spx(i);
          ml1 = ml_spx(i);
          do j = i , nf+ng
              fg2 = fg_spx(j);
              ml2 = ml_spx(j);
              if( fg1 .eq. fg2 ) then
                  if( abs(ml1-ml2) .eq. K_multipol ) then
                      broyd_nn = broyd_nn + 1;
                  endif
              endif
              if( fg1 .ne. fg2 ) then
                  if( abs(ml1-ml2) .eq. K_multipol ) then
                      broyd_nn = broyd_nn + 1;
                  endif
                  if( abs(ml1+ml2+1) .eq. K_multipol ) then
                      broyd_nn = broyd_nn + 1;
                  endif
              endif
          enddo
      enddo
      do i = 1 , nf+ng
          fg1 = fg_spx(i);
          ml1 = ml_spx(i);
          do j = i , nf+ng
              fg2 = fg_spx(j);
              ml2 = ml_spx(j);
              if( fg1.ne.'f' .or. fg2.ne.'f' ) CYCLE;
              if( abs(ml1-ml2) .ne. K_multipol ) CYCLE;
              broyd_nn = broyd_nn + 1; !dDelta_plus
              broyd_nn = broyd_nn + 1; !dDelta_minus
          enddo
      enddo
      broyd_nn = 2*broyd_nn; !protoni neutroni
      broyd_nn = 2*broyd_nn; !real/imag
c---------------------------------------------------------










c-----Nastimavam WSIZE
      K = K_multipol;
      WSIZE = 0;
      do i = 1 , nf+ng
          fg1 = fg_spx(i);
          nz1 = nz_spx(i);
          nr1 = nr_spx(i);
          ml1 = ml_spx(i);

          do j = i , nf+ng
              fg2 = fg_spx(j);
              nz2 = nz_spx(j);
              nr2 = nr_spx(j);
              ml2 = ml_spx(j);



              if( fg1.eq.'f' .and. fg2.eq.'f' ) then
                  if( abs(ml1-ml2) .eq. K_multipol ) then

                      do NRR = 0 , nr1+nr2+(abs(ml1)+abs(ml2)-K)/2
                          do NZZ = 0 , nz1+nz2
                              if(mod(NZZ,2).ne.mod(nz1+nz2,2)) CYCLE;
                              WSIZE = WSIZE + 1;
                          enddo
                      enddo

                  endif
              endif



          enddo
      enddo
c---------------------------------------------------------












c-----Slijedi jako ruzan kod jer Fortran ne moze proizvoljno dugacke linije... :(
      open( 123 , file = './source/dirhb.par' );

      write(123,'(2a)')
     & 'c--------------------------------------------------',
     & '---------------------';
      write(123,'(a)')'c     Parameter file for:';
      write(123,'(a)')'c     n0f =  20   n0b =  20';
      write(123,'(2a)')
     & 'c--------------------------------------------------',
     & '---------------------';
      write(123,'(a)')'c';
      write(123,'(a)')'c---- maximal number for GFV';
      write(123,'(a)')'      parameter (      IGFV =       100 )';
      write(123,'(a)')'c';
      write(123,'(a)')'c---- number of r-meshpoints (4n+1 points)';
      write(123,'(a)')'      parameter (      RMAX =  15.00000 )';
      write(123,'(a)')'      parameter (      MR =       301 )';
      write(123,'(a)')'c';
      write(123,'(a)')'c---- number of q-meshpoints (4n+1 points)';
      write(123,'(a)')'      parameter (      QMAX =   6.00000 )';
      write(123,'(a)')'      parameter (      MQ =        49 )';
      write(123,'(a)')'c';
      write(123,'(a)')'c---- number of gauss-meshpoints';
      write(123,'(a,i2,a)')'      parameter (     NGH =        ',NGH,
     &                     ' )';
      write(123,'(a,i2,a)')'      parameter (     NGL =        ',NGL,
     &                     ' )';
      write(123,'(a)')'      parameter (     NGLEG =      18 )';
      write(123,'(a)')'c';
      write(123,'(2a)')'c---- maximal oscillator quantum number ',
     &            'for fermions';
      write(123,'(a,i2,a)')'      parameter (     N0FX =       ',n0f,
     &                     ' )';
      write(123,'(a)')'      parameter (     nxx  =       N0FX/2)';
      write(123,'(a)')'c';
      write(123,'(a)')'c---- maximal number of (k,parity)-blocks';
      write(123,'(3a)')'      parameter (     NBX =  2*N0FX+1   +  2 )',
     &                 '                 !abjelcic: tu sam dodao +2',
     &                 ' zbog dva visoka stanja koja fale!!!!';
      write(123,'(a)') '';
      write(123,'(2a)')'c---- max. number of all levels for ',
     &                 'protons or neutrons';
      write(123,'(2a)')'      parameter (     NTX1 = 2*(nxx+1)*(nxx+2)*'
     &                ,'(2*nxx+3)/3-1 )';
      write(123,'(a)')'      parameter (     NTX2 = (2*nxx+1)*(nxx+1) )';
      write(123,'(2a)')'      parameter (     NTX3 = 2*nxx*(nxx+1)*',
     &                 '(2*nxx+1)/3  )';
      write(123,'(3a)')'      parameter (     NTX  = NTX1+NTX2+NTX3-1  '
     &                ,'+ 2 )           !abjelcic: tu sam dodao +2 '
     &                ,'zbog dva visoka stanja koja fale!!!!';
      write(123,'(1a)')'c';
      write(123,'(1a)')'';
      write(123,'(a,i4,a)')'      parameter( NBSX         = ', NBSX, ')';
      write(123,'(4a)')'      parameter( J_MAX        =  3 )',
     &                 '                           !abjelcic: tu ',
     &                 'sam dodao da je maximalno ',
     &                 'do oktupola!!!!';

      write(123,'(a,i10,4a)')'      parameter( NFAM_BROYD_NN = ',
     &                       broyd_nn,
     &                       ' )',
     &                       '                  ',
     &                       '!abjelcic: tu sam dodao dimenziju nn iz',
     &                       ' Broydena!!!!';
      write(123,'(3a)')'      parameter( NFAM_BROYD_MM = 20 )     ',
     &                 '                     !abjelcic: tu sam dodao ',
     &                 'dimenziju mm iz Broydena!!!!';



c      write(123,'(a,i6,4a)')'      parameter( J_multipole  =  ',
c     &                      J_multipol,
c     &                      ' )',
c     &                      '                      ',
c     &                      '!abjelcic: tu sam dodao J da je poznat',
c     &                      ' u compile time-u!!!!';
c      write(123,'(a,i6,4a)')'      parameter( K_multipole  =  ',
c     &                      K_multipol,
c     &                      ' )',
c     &                      '                      ',
c     &                      '!abjelcic: tu sam dodao K da je poznat',
c     &                      ' u compile time-u!!!!';
      
      write(123,'(a,i10,4a)')'      parameter( NWMAX  =        ',
     &                       WSIZE,
     &                       ' )',
     &                       '                  ',
     &                       '!abjelcic: tu sam dodao dimenziju',
     &                       ' od W iz pairinga!!!!';



      write(123,'(1a)') '';
      write(123,'(2a)')'c---- max. number of eigenstates',
     &                 ' for protons or neutrons';
      write(123,'(1a)')'      parameter ( KX1 = (nxx+1)**2)';
      write(123,'(2a)')'      parameter ( KX2 = 2*nxx*(nxx+1)',
     &                 '*(2*nxx+1)/3 )';
      write(123,'(1a)')'      parameter ( KX3 = nxx*(nxx+1) )';
      write(123,'(1a)')'      parameter ( KX4 = KX1+KX2+KX3 )';
      write(123,'(1a)')'      parameter ( KX  =     NTX-KX4 )';
      write(123,'(1a)')'c';
      write(123,'(1a)')'c---- max. nz-quantum number of fermions';
      write(123,'(1a)')'      parameter (     NZX  =   N0FX+1 )';
      write(123,'(1a)')'c';
      write(123,'(1a)')'c---- max. nr-quantum number of fermions';
      write(123,'(1a)')'      parameter (     NRX  = nxx )';
      write(123,'(1a)')'c';
      write(123,'(1a)')'c---- max. ml-quantum number of fermions';
      write(123,'(1a)')'      parameter (     MLX  =        N0FX+1 )';
      write(123,'(1a)')'c';
      write(123,'(1a)')'c---- maximal dimension F of one k-block';
      write(123,'(2a)')'      parameter (     NFX  =      ',
     &                 ' (nxx+1)**2 )';
      write(123,'(1a)')'c';
      write(123,'(1a)')'c---- maximal dimension G of one k-block';
      write(123,'(2a)')'      parameter (     NGX  =       ',
     &                 '(nxx+1)*(nxx+2) )';
      write(123,'(1a)')'c';
      write(123,'(1a)')'c---- maximum of nf and ng in all blocks';
      write(123,'(1a)')'      parameter (     NDX  =       NGX )';
      write(123,'(1a)')'c';
      write(123,'(1a)')'c---- oscillator quantum number for bosons';
      write(123,'(1a)')'      parameter (     N0BX =        20 )';
      write(123,'(1a)')'c';
      write(123,'(1a)')'c---- number of bosons';
      write(123,'(1a)')'      parameter (     nbxx = N0BX/2 )';
      write(123,'(2a)')'      parameter (     NOX  =  ',
     &                 '(nbxx+1)*(nbxx+2)/2 )';
      write(123,'(1a)')'c---- for the plot';
      write(123,'(2a)')'      parameter (     NOX1 = ',
     &                 '(N0FX+1)*(N0FX+2)/2)';
      write(123,'(1a)')'c';
      write(123,'(2a)')'c----------------------------------',
     &                 '-------------------------------------';
      write(123,'(1a)')'c';
      write(123,'(1a)')'      parameter ( NGH2   = NGH+NGH )';
      write(123,'(1a)')'      parameter ( NB2X   = NBX+NBX )';
      write(123,'(1a)')'      parameter ( NHX    = NFX+NGX )';
      write(123,'(1a)')'      parameter ( NDDX   = NDX*NDX )';
      write(123,'(1a)')'      parameter ( NHBX   = NHX+NHX )';
      write(123,'(1a)')'      parameter ( NHBQX  = NHBX*NHBX )';
      write(123,'(1a)')'      parameter ( NFFX   = NFX*NFX )';
      write(123,'(1a)')'      parameter ( NFGX   = NFX*NGX )';
      write(123,'(1a)')'      parameter ( NHHX   = NHX*NHX )';
      write(123,'(1a)')'      parameter ( MG     = (NGH+1)*(NGL+1) )';
      write(123,'(1a)')'      parameter ( N02    = 2*N0FX )';
      write(123,'(2a)')'      parameter ( NNNX   = ',
     &                 '(N0FX+1)*(N0FX+1) )';
      write(123,'(1a)')'c';
      write(123,'(1a)')'c---- working space';
      write(123,'(2a)')'      parameter ( MVX1    = ',
     &                 '( (nxx+1)**4+(nxx+1)**2)/2 )';
      write(123,'(2a)')'      parameter ( MVX2a   = ',
     &                 'nxx*(nxx+1)*(2*nxx+1) )';
      write(123,'(2a)')'      parameter ( MVX2    = ',
     &                 'MVX2a*(3*nxx**2+3*nxx-1)/15 )';
      write(123,'(2a)')'      parameter ( MVX3    = ',
     &                 'nxx*(nxx+1)*(2*nxx+1)/2  )';
      write(123,'(2a)')'      parameter ( MVX4    = ',
     &                 'nxx**2*(nxx+1)**2/2  )';
      write(123,'(1a)')'      parameter ( MVX5    = nxx*(nxx+1)/2  )';
      write(123,'(2a)')'      parameter ( MVX     = ',
     &                 'MVX1+MVX2+MVX3+MVX4+MVX5 )';
      write(123,'(1a)')'';
      write(123,'(1a)')'      parameter (MSUM1    =  nxx*(nxx+1)/2 )';
      write(123,'(2a)')'      parameter (MSUM2    =  ',
     &                 'nxx*(nxx+1)*(2*nxx+1)/6 )';
      write(123,'(2a)')'      parameter (MSUM3    =  ',
     &                 'nxx**2*(nxx+1)**2/4 )';
      write(123,'(2a)')'      parameter (MSUM4 =  nxx*(nxx+1)',
     &                 '*(2*nxx+1)*(3*nxx**2+3*nxx-1)/30 )';
      write(123,'(2a)')'      parameter (MVTX1 = 6+7*nxx+4*MSUM4',
     &                 '+16*MSUM3+27*MSUM2+22*MSUM1   )';
      write(123,'(2a)')'      parameter (MVTX2    = nxx+4*MSUM4',
     &                 '+8*MSUM3+9*MSUM2+5*MSUM1 )';
      write(123,'(1a)')'      parameter (MVTX     = MVTX1+MVTX2   )';

      close( 123 );

      write(6,*) '';
      write(6,'(2a)') 'Sacekati trenutak dok compile-am',
     &                ' sa svim optimizacijama...';
      write(6,*) '';


      return
      end
